import os
import re
import sys
import requests
import shutil
import json
import stat
from os import path
from colorama import Fore, init
import psutil

if psutil.Process(os.getpid()).parent().name() == 'cmd.exe':
    init(convert=True)


def createPath(path):
    if not os.path.exists(path):
        os.makedirs(path, 777)
        return True


def getConfigDir():
    if sys.platform == "win32" :
        app_config_dir = os.getenv("LOCALAPPDATA")
    else :
        app_config_dir = os.getenv("HOME")
        if os.getenv("XDG_CONFIG_HOME"):
            app_config_dir = os.getenv("XDG_CONFIG_HOME")

    config_dir = os.path.join(os.path.join(app_config_dir, ".localconfig"), 'configstore')
    createPath(config_dir);
    if os.path.exists(config_dir) and not os.path.isfile(os.path.join(config_dir, 'ResuME.json')):
        with open(os.path.join(config_dir, 'ResuME.json'), 'w') as cf:
            json.dump({}, cf)
    return config_dir


def setENV(envs):
   with open(os.path.join(getConfigDir(), 'ResuME.json'), 'w') as f:
        json.dump(envs, f)


def getENV(item):
    with open(os.path.join(getConfigDir(), 'ResuME.json')) as f:
        data = json.load(f)
    return data[item]


def verifyLinkedinURL(url):
    link = re.compile('((http(s?)://)*([www])*\.|[linkedin])[linkedin/~\-]+\.[a-zA-Z0-9/~\-_,&=\?\.;]+[^\.,\s<]')
    return(link.match(url))


def builder(data):
    dta = json.loads(data)
    # get output path
    output = getENV("Output");
    path_output = os.path.join(output, 'ResuMe-Output')
    # create output directory if it doesn't exist
    if not os.path.exists(path_output):
        createPath(path_output);
    # check if folder exists in the Output directory or github repo
    dest = path_output+"/ResuMe-"+dta['profile']['name'].replace(" ","-")
    if(os.path.isdir(dest)):
        return True;
    name = dta['profile']['name']
    if(name.endswith('.')):
        name = dta['profile']['name'][:-1]
    github(name,data)


def github(name, data):
    # get output path
    Output = getENV("Output");
    path_output = os.path.join(Output, 'ResuMe-Output')
    dest = "/ResuMe-"+name.replace(" ","-")
    pat = getENV("PAT")
    owner = getENV("owner")
    # clone template folder into path_output as dest
    os.chdir(path_output);
    PAT = getENV("PAT");
    os.system('git clone https://'+pat+'@github.com/ishita1805/ResuMe-Template.git .'+dest);

    API_URL = 'https://api.github.com'
    payload = '{ "name":"ResuMe-'+name.replace(" ","-")+'", "description":"This repository is auto generated by ResuME-Website Generator" }'
    headers = {
        "Authorization": "token "+pat,
        "Accept": "application/vnd.github.v3+json"
    }
    # create a new repo
    requests.post(API_URL+'/user/repos',data=payload, headers=headers)
    os.chdir(path_output+dest)
    # copy data into data.json
    with open("./data.json", "w") as outfile:
            outfile.write(data)
    # push to github
    os.system("git add .")
    os.system("git commit -m 'website-generated'")
    os.system("git remote set-url origin https://github.com/"+owner+"/ResuMe-"+name.replace(" ","-")+".git")
    os.system("git branch -M main")
    os.system("git push -u origin main")
    

def updateBuilder(data):
    dta = json.loads(data)
    # check if folder doesn't exists
    output = getENV("Output");
    path_output = os.path.join(output, 'ResuMe-Output')
    dest = path_output+"/ResuMe-"+dta['profile']['name'].replace(" ","-")
    if(os.path.isdir(dest)==False):
        return True;
    # add data.json to output folder 
    with open(path_output+"/ResuMe-"+dta['profile']['name'].replace(" ","-")+"/data.json", "w") as outfile:
        outfile.write(data)
    # push to github
    os.chdir(path_output+"/ResuMe-"+dta['profile']['name'].replace(" ","-"))
    if(os.system('git rev-parse --verify gh-pages') == 0):
        os.system("git add .")
        os.system("git commit -m 'website-updated'")
        os.system('git push --set-upstream origin gh-pages -f')
    else:
        os.system("git add .")
        os.system("git commit -m 'website-updated'")
        os.system("git push origin master -f")


def deployer(repo):
    # change directory and create a new branch
    output = getENV("Output");
    path_output = os.path.join(output, 'ResuMe-Output')
    os.chdir(path_output+'/'+repo)
    os.system('git checkout -b gh-pages')
    
    # modify readme file
    f = open('./README.md','a')
    f.write('\n**your ResuMe is deployed at:** https://'+getENV('owner')+'.github.io/'+repo+'\n')
    f.close()
    # push new branch to github
    os.system("git add .")
    os.system("git commit -m 'website-deployed'")
    os.system("git push origin gh-pages")

    return 'https://'+getENV('owner')+'.github.io/'+repo+'/'


def list():
    # get output path
    output = getENV("Output");
    path_output = os.path.join(output, 'ResuMe-Output')
    if(os.path.exists(path_output)):
        os.chdir(path_output);
        list = os.listdir();
        if(len(list) <= 0):
            print(Fore.RED+'No ResuMe\'s Available, Try the command: `resume-cli build`'+Fore.WHITE)
        else:
            print(Fore.LIGHTGREEN_EX+'Available ResuMe\'s:'+Fore.WHITE)
            for i in range(0,len(list)):
                print(Fore.LIGHTGREEN_EX+list[i].strip()+Fore.WHITE)
    else:
        print(Fore.RED+'No ResuMe\'s Available, Try the command: `resume-cli build`'+Fore.WHITE)
        


def delRepo(repo):
    # get output path
    output = getENV("Output");
    path_output = os.path.join(output, 'ResuMe-Output')
    os.chdir(path_output)
    check = False
    # check if repo exists
    list = os.listdir()
    for i in range(0,len(list)):
        if(list[i] == repo):
            check = True
    if(check == False):
        print(Fore.RED+'Error: ResuMe not found'+Fore.WHITE)
        return;
    # delete this repo from output directory
    for root, dirs, files in os.walk(repo):  
        for dir in dirs:
            os.chmod(path.join(root, dir), stat.S_IRWXU)
        for file in files:
            os.chmod(path.join(root, file), stat.S_IRWXU)
    shutil.rmtree(repo)
    
    # delete this repo from github
    pat = getENV("PAT")
    owner = getENV("owner")
    api_url = 'https://api.github.com/repos/'+owner+'/'+repo
    Headers = {
        "Authorization": "token "+pat,
        "Accept": "application/vnd.github.v3+json"
    }
    requests.delete(api_url, headers=Headers)
    print(Fore.GREEN+'\nResuMe Deleted'+Fore.WHITE)